# #
# $Date: 1996/06/20 12:17:33 $  $Author: frankp $   $Revision: 1.14 $ #
# #
# frankp, 29/07/94 #

#++
    crossmul.mu

    linalg::crossProduct(u,v) 

    u,v: vectors of length 3

    Returns the vector cross product of u and v where u and v are
    vectors over the same coeffRing, each with three elements.

++#

linalg::crossProduct := proc(u,v)
    name linalg::crossProduct;
    local R, Rmult, Rplus, Rnegate;
begin
    if testargs() then
        if args(0) <> 2 then error("wrong no of args") end_if;
	if not testtype( u,linalg::VectorOf(Type::AnyType,3) ) then
	    error("expecting vectors of dimension 3")
	end_if;
	if not testtype( v,linalg::VectorOf(u::coeffRing,3) ) then
	    error("vectors are not compatible")
	end_if
    end_if;

    R:= u::coeffRing;
    Rmult:= R::_mult;
    Rplus:= R::_plus;
    Rnegate:= R::negate;

    u::newThis( op(u::dimen(u)), [
	Rplus( Rmult(u[2],v[3]), Rnegate(Rmult(u[3],v[2])) ),
	Rplus( Rmult(u[3],v[1]), Rnegate(Rmult(u[1],v[3])) ),
	Rplus( Rmult(u[1],v[2]), Rnegate(Rmult(u[2]*v[1])) )
    ])
end_proc:
