ode::solve_sys := proc(sys,unks) # unks is a set #
local is_linear,eq,inits,_l,y,z,maxord,s,i,j,A,ll,b,m,k,sol,n;
begin
   _l:={}; z:={};
   for eq in unks do
      if type(eq)="function" then
         if type((y:=op(eq,0)))=DOM_IDENT and nops(eq)=1 then
            _l:=_l union {y};
            z:=z union {op(eq)};
            next
         end_if
      end_if;
      error("invalid unknown function")
   end_for;
   if nops(z)<>1 then error("wrong number of independent variables") end_if;
   z:=op(z);
   n:=nops(_l); # number of unknowns functions #
   # first split equations and initial conditions #
   eq:=ode::split(sys,z);
   sys:=eq[1]; inits:=eq[2];
   if nops(sys)<>n then error("number of equations differs from number of unknowns") end_if;
   # check the equations and compute the maximal order #
   maxord:=ode::order(sys,_l);
   userinfo(1,"differential system of order ".maxord." with ".n." functions");
   # recognize linear systems #
   _l:=[op(_l)]; # to set the order #
   s:=[(diff(_l[i](z),z$j) $ i=1..n) $ j=0..maxord];
   m:=n*(maxord+1);
   is_linear:=TRUE; b:=[];
   for k from 0 to maxord do A[k]:=[[0$n]$n] end_for;
   for i from 1 to n do
      if (ll:=Type::Linear(op(sys,i),s))<>FALSE then
         b:=append(b,ll[m+1]);
         for k from 0 to maxord do
            for j from 1 to n do A[k][i][j]:=ll[k*n+j] end_for;
         end_for;
      else is_linear:=FALSE; break
      end_if
   end_for;
   sol:=FAIL;
   if is_linear then sol:=ode::linsys(A,b,_l,z,n,maxord,n)
   else
      userinfo(1,"nonlinear system");
      if maxord=1 then
         sol:=ode::combination(sys,unks,z);
         if sol=FAIL then sol:=ode::matrixRiccati(sys,unks,z) end_if;
      end_if;
   end_if;
   if sol<>FAIL then return(sol) end_if;
   # try to recognize a triangular system #
   for eq in sys do
      hastype; # to load Indets #
      s:=Indets(eq,"function") intersect unks;
      if nops(s)=1 then
         userinfo(1,"found one independent equation");
         s:=op(s); # x(t) #
         sol:=ode::solve_eq(eq,op(s,0),op(s));
         if not has(sol,FAIL) and nops(sol)=1 then
            sol:={s=op(sol)};
            sys:=eval(subs(sys minus {eq},sol));
            unks:=unks minus {s};
            if nops(unks)=1 then
               s:=op(unks);
               sys:=ode::solve_eq(op(sys),op(s,0),op(s));
               if has(sys,FAIL) then sys:=FAIL 
               else
                  sys:=ode::mapsol(sys,fun({s=args(1)}));
                  sys:=map(sys,fun((if type(args(1))=DOM_SET then args(1)
			else {args(1)} end_if)));
               end_if;
            else sys:=ode::solve_sys(sys,unks)
            end_if;
            if type(sys)=DOM_SET then
               return(map(sys,_union,sol))
            end_if
         end_if
      end_if
   end_for;
   {sol}
end_proc:

sysassign(ode::combination,
	loadproc(ode::combination,pathname("ODE"),"combinat")):
sysassign(ode::matrixRiccati,
	loadproc(ode::matrixRiccati,pathname("ODE"),"mriccati")):
