/* $Date: 1996/09/25 13:49:42 $  $Author: olli $  $Revision: 1.6 $ */

/**************************************************************************/
/* FILE:             MPH_problemheap.h 					  */
/* Autor:            Karsten Morisse                                      */
/* Erstellt:         02/01/92                                             */
/* Letzte Aenderung: 20/02/92                                             */
/**************************************************************************/

#ifndef __MPH_problemheap__
#define __MPH_problemheap__


/**************************************************************************/
/* Dieses File enthaelt die Deklarationen des Modules MPH_problemheap     */
/**************************************************************************/

/**************************************************************************/
/* In MPHTsave werden wichtige Werte f"ur ein Task gespeichert, die keine */
/* S-Zeiger sind.                                                         */
/**************************************************************************/
typedef struct
   {
      long MUPV_REAL_PROC_DEPTH ;
   } MPHTsave ;



	/* Zeiger auf Problemheap					  */
	/* ACHTUNG: Wird nur im Fall 'PARALLEL' wirklich benoetigt.	  */
	/*          Aus Kompatibilitaetsgruenden wird sie jedoch in 	  */
	/*	    beiden Faellen deklariert.				  */

#define MPHC_HISTORY_SIZE_DEFAULT 30


extern S_Pointer	MPHV_START;	



void MPH_delete_subtasks(S_Pointer parallel_env) ;


#ifdef PARALLEL

S_Pointer MPH_build_task(S_Pointer stmt, S_Pointer priv, S_Pointer cnt, S_Pointer res, S_Pointer ret);

void MPH_do_task(S_Pointer stmt, S_Pointer priv, S_Pointer res, S_Pointer ret, S_Pointer aktparenv);
MUPbool MPH_get(VOID);
void MPH_get_sleep(VOID) ;
void MPH_init(VOID);
void MPH_exit(VOID);
void MPH_put(S_Pointer task);
void MPH_prepare_stack(S_Pointer priv, long flag);

#else

S_Pointer MPH_get_random(long);
S_Pointer MPH_get_task(VOID);
S_Pointer MPH_build_task(S_Pointer stmt, S_Pointer priv, S_Pointer cnt, S_Pointer res, S_Pointer ret);
 
MUPbool MPH_get(long);
#define MPH_get_sleep() MPH_get(1L) 
void MPH_init(VOID);
void MPH_exit(VOID);
void MPH_put(S_Pointer task);
void MPH_prepare_stack(S_Pointer priv, long flag);
 
long MPH_count_problemheap(VOID);
 
#endif /* PARALLEL */

#endif /* __MPH_problemheap__ */
